package mooctest.org.backend.site.command;

import lombok.Data;
import mooctest.org.backend.site.domainObject.Notification;
import mooctest.org.backend.site.factory.NotificationFactory;
import org.springframework.beans.BeanUtils;

import javax.validation.constraints.NotNull;

/**
 * @author guochao
 * @date 2019-12-18 20:34
 */
@Data
public class NotificationCommand {
    @NotNull(message = "title不可为空")
    private String title;
    @NotNull(message = "内容不可为空")
    private String content;
    private String ossUrl;
    private String pictureUrl;
    private int type;
    private int isThirdParty;
    private int isChangingCreateTime = 0;

    public Notification toNotification(){
        Notification notification = NotificationFactory.CreateNotification();
        BeanUtils.copyProperties(this, notification);
        if(this.ossUrl != null && this.ossUrl != ""){
            notification.setOssUrl(this.ossUrl);
        }
        if(this.pictureUrl != null && this.pictureUrl != ""){
            notification.setPictureUrl(this.pictureUrl);
        }
        return notification;
    }
}
