package mooctest.org.backend.site.dao;

import mooctest.org.backend.site.model.NotificationPO;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Component;
import java.util.Optional;
import java.util.List;

/**
 * @author guochao
 * @date 2019-12-18 17:38
 */
@Component
public interface NotificationDao extends CrudRepository<NotificationPO, Long> {

    @Query(value = "select * from notification where N_IS_DELETED = ?1 order by N_TYPE DESC, N_CREATE_TIME DESC limit ?2", nativeQuery = true)
    List<NotificationPO> findOrderByIdDescLimit(Integer notDeleted, int limitCount);

    @Query(value = "select * from notification where N_IS_DELETED = ?1 order by N_TYPE DESC, N_CREATE_TIME DESC", nativeQuery = true)
    List<NotificationPO> findAll(Integer notDeleted);

    @Query(value = "select * from notification where N_TYPE = ?1 and N_IS_DELETED = ?2 order by N_CREATE_TIME DESC", nativeQuery = true)
    List<NotificationPO> findAllByType(int type, Integer notDeleted);

    Optional<NotificationPO> findByIdAndDeletedStatus(Long id, int deletedStatus);

}
