package mooctest.org.backend.site.domainObject;

import lombok.Data;
import mooctest.org.backend.site.command.NotificationCommand;
import mooctest.org.backend.site.data.DeletedStatus;
import mooctest.org.backend.site.data.NotificationType;

import javax.persistence.*;
import java.io.Serializable;
import java.sql.Timestamp;

/**
 * @author guochao
 * @date 2019-12-18 17:40
 */
@Data
public class Notification {
    private Long id;
    private String title;
    private String content;
    private String pictureUrl;
    private String ossUrl;
    private int type;
    private int isThirdParty;
    private int deletedStatus;
    private int isChangingCreateTime = 0;
    private Timestamp createTime;
    private int year;


    public Notification createNotification(){
        this.setCreateTime(new Timestamp(System.currentTimeMillis()));
        return this;
    }


    public void update(NotificationCommand notificationModify) {
        this.setTitle(notificationModify.getTitle());
        this.setContent(notificationModify.getContent());
        if(notificationModify.getPictureUrl() != null && notificationModify.getPictureUrl() != ""){
            this.setOssUrl(notificationModify.getPictureUrl());
        }
        if(notificationModify.getOssUrl() != null && notificationModify.getOssUrl() != ""){
            this.setOssUrl(notificationModify.getOssUrl());
        }
        if(notificationModify.getIsChangingCreateTime() == 1){
            this.setCreateTime(new Timestamp(System.currentTimeMillis()));
        }
        this.setType(notificationModify.getType());
    }

    public void delete() {
        this.deletedStatus = DeletedStatus.IS_DELETED;
    }

    public void changeTypeToNew() {
        this.type = NotificationType.NEW;
    }

    public void changeTypeToGeneration() {
        this.type = NotificationType.GENERATION;
    }
}
